# http://rise4fun.com/Z3Py/uaW

b_1, b_2, b_3, b_4 = Bools('b_1 b_2 b_3 b_4')

d1 = Or(b_1, Not(b_2), Not(b_3))
d2 = Or(b_1, b_2, b_4)
P = And(d1, d2)

print 'SAT:'
s = Solver()

s.add(P)

r = s.check()
print r
if r == sat:
  print s.model()
else:
  print formulaPart
  
print 'QBF:'
s = Solver()

#f = Exists([b_3, b_4], ForAll([b_1, b_2], P))
f = ForAll([b_1, b_2], P) # b_3, b_4 implicitly existentially quantified outside
s.add(f)

r = s.check()
print r
if r == sat:
  print s.model()
else:
  print f